<?php

function wfmtest_add_metabox() {
	add_meta_box( 'book_info_metabox', 'Данные книги', 'wfmtest_add_metabox_cb', array( 'book' ) );
}

function wfmtest_add_metabox_cb( $post ) {

	wp_nonce_field( 'wfmtest_action', 'wfmtest_nonce' );

	$book_pages = get_post_meta( $post->ID, 'book_pages', true );
	$book_cover = get_post_meta( $post->ID, 'book_cover', true );

	?>

    <table class="form-table">
        <tbody>

        <tr>
            <th><label for="book_pages">Кол-во страниц:</label></th>
            <td><input type="text" id="book_pages" name="book_pages" class="regular-text"
                       value="<?php echo esc_attr( $book_pages ) ?>"></td>
        </tr>

        <tr>
            <th><label for="book_cover">Обложка?</label></th>
            <td><input type="checkbox" id="book_cover" name="book_cover" <?php checked( 'yes', $book_cover ) ?>></td>
        </tr>

        </tbody>
    </table>

	<?php
}

add_action( 'add_meta_boxes', 'wfmtest_add_metabox' );

function wfmtest_save_metabox( $post_id ) {
	if ( ! isset( $_POST['wfmtest_nonce'] ) || ! wp_verify_nonce( $_POST['wfmtest_nonce'], 'wfmtest_action' ) ) {
		return;
	}

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return;
	}

	if ( ! current_user_can( 'edit_post', $post_id ) ) {
		return;
	}

	if ( ! empty( $_POST['book_pages'] ) ) {
		update_post_meta( $post_id, 'book_pages', sanitize_text_field( $_POST['book_pages'] ) );
	} else {
		delete_post_meta( $post_id, 'book_pages' );
	}

	if ( isset( $_POST['book_cover'] ) && $_POST['book_cover'] == 'on' ) {
		update_post_meta( $post_id, 'book_cover', 'yes' );
	} else {
		delete_post_meta( $post_id, 'book_cover' );
	}

}

add_action( 'save_post', 'wfmtest_save_metabox' );
